/* This is an autogenerated file from sme__build_signal_c.pl */
/* Tag: noCheckHeader */

/*    CONFIDENTIAL */
/*    Copyright (C) Cambridge Silicon Radio Ltd 2008. All rights reserved. */

#include "fsm/fsm.h" 
#include "hostio/hip_fsm_types.h"
#include "smeio/smeio_fsm_types.h"
#include "smeio/smeio_fsm_events.h"
#include "event_pack_unpack/event_pack_unpack.h"

uint16 build_packed_unifi_sys_wifi_on_ind(uint8** resultBuffer, unifi_Status status, const unifi_Versions* versions)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    /* packedSize += 4;  versions->chipId */
    /* packedSize += 4;  versions->chipVersion */
    /* packedSize += 4;  versions->firmwareBuild */
    /* packedSize += 4;  versions->firmwareHip */
    /* packedSize += 4;  versions->driverBuild */
    /* packedSize += 4;  versions->driverHip */
    /* packedSize += 4;  versions->driverApi */
    /* packedSize += 4;  versions->smeBuild */
    /* packedSize += 4;  versions->smeVariant */
    /* packedSize += 4;  versions->smeDriverApi */
    /* packedSize += 4;  versions->smeHip */
    /* packedSize += 4;  versions->smeSapApi */
    packedSize += (uint16)osa_strlen(versions->smeIdString) + 3; /* unifi_String :: smeIdString */
    packedSize += 50; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_WIFI_ON_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->chipId); /* chipId */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->chipVersion); /* chipVersion */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->firmwareBuild); /* firmwareBuild */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->firmwareHip); /* firmwareHip */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->driverBuild); /* driverBuild */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->driverHip); /* driverHip */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->driverApi); /* driverApi */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->smeBuild); /* smeBuild */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->smeVariant); /* smeVariant */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->smeDriverApi); /* smeDriverApi */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->smeHip); /* smeHip */
    packedLength += event_pack_uint32(&buffer, (uint32)versions->smeSapApi); /* smeSapApi */
    packedLength += event_pack_string(&buffer, versions->smeIdString); /* unifi_String : smeIdString */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_wifi_on_cfm(uint8** resultBuffer, unifi_Status status)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_WIFI_ON_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_wifi_off_ind(uint8** resultBuffer, unifi_ControlIndication controlIndication)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  controlIndication */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_WIFI_OFF_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)controlIndication); /* controlIndication */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_wifi_off_cfm(uint8** resultBuffer)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_WIFI_OFF_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_suspend_ind(uint8** resultBuffer, Boolean hardSuspend, Boolean d3Suspend)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  hardSuspend */
    /* packedSize += 2;  d3Suspend */
    packedSize += 4; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_SUSPEND_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_int16(&buffer, (int16)hardSuspend); /* hardSuspend */
    packedLength += event_pack_int16(&buffer, (int16)d3Suspend); /* d3Suspend */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_resume_ind(uint8** resultBuffer, Boolean resumePowerMaintained)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  resumePowerMaintained */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_RESUME_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_int16(&buffer, (int16)resumePowerMaintained); /* resumePowerMaintained */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_hip_ind(uint8** resultBuffer, const unifi_DataBlock* mlmeCommand, const unifi_DataBlock* dataRef1, const unifi_DataBlock* dataRef2)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    packedSize += mlmeCommand->length + 2; /*lint !e725*/ /* unifi_DataBlock :: mlmeCommand */
    packedSize += dataRef1->length + 2; /*lint !e725*/ /* unifi_DataBlock :: dataRef1 */
    packedSize += dataRef2->length + 2; /*lint !e725*/ /* unifi_DataBlock :: dataRef2 */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_HIP_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, mlmeCommand->length); /*lint !e725 unifi_DataBlock : mlmeCommand */
    packedLength += event_pack_buffer(&buffer, mlmeCommand->data, mlmeCommand->length); /*lint !e545 !e725 unifi_DataBlock : mlmeCommand */
    packedLength += event_pack_uint16(&buffer, dataRef1->length); /*lint !e725 unifi_DataBlock : dataRef1 */
    packedLength += event_pack_buffer(&buffer, dataRef1->data, dataRef1->length); /*lint !e545 !e725 unifi_DataBlock : dataRef1 */
    packedLength += event_pack_uint16(&buffer, dataRef2->length); /*lint !e725 unifi_DataBlock : dataRef2 */
    packedLength += event_pack_buffer(&buffer, dataRef2->data, dataRef2->length); /*lint !e545 !e725 unifi_DataBlock : dataRef2 */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_qos_control_cfm(uint8** resultBuffer, unifi_Status status)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_QOS_CONTROL_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_port_configure_cfm(uint8** resultBuffer, unifi_Status status, const unifi_MACAddress* macAddress)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    /* packedSize += 6;  macAddress->data */
    packedSize += 8; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_PORT_CONFIGURE_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    packedLength += event_pack_buffer(&buffer, (uint8*)&macAddress->data, 6); /*lint !e545 !e725    data */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_traffic_sample_ind(uint8** resultBuffer, const unifi_traffic_stats* stats)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 4;  stats->rxFramesNum */
    /* packedSize += 4;  stats->txFramesNum */
    /* packedSize += 4;  stats->rxBytesCount */
    /* packedSize += 4;  stats->txBytesCount */
    /* packedSize += 11;  stats->intervals */
    packedSize += 27; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_TRAFFIC_SAMPLE_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint32(&buffer, (uint32)stats->rxFramesNum); /* rxFramesNum */
    packedLength += event_pack_uint32(&buffer, (uint32)stats->txFramesNum); /* txFramesNum */
    packedLength += event_pack_uint32(&buffer, (uint32)stats->rxBytesCount); /* rxBytesCount */
    packedLength += event_pack_uint32(&buffer, (uint32)stats->txBytesCount); /* txBytesCount */
    packedLength += event_pack_buffer(&buffer, (uint8*)&stats->intervals, 11); /*lint !e545 !e725    intervals */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_traffic_protocol_ind(uint8** resultBuffer, unifi_traffic_packettype packetType, unifi_protocol_direction direction, const unifi_MACAddress* srcAddress)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  packetType */
    /* packedSize += 2;  direction */
    /* packedSize += 6;  srcAddress->data */
    packedSize += 10; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_TRAFFIC_PROTOCOL_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)packetType); /* packetType */
    packedLength += event_pack_uint16(&buffer, (uint16)direction); /* direction */
    packedLength += event_pack_buffer(&buffer, (uint8*)&srcAddress->data, 6); /*lint !e545 !e725    data */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_ip_configured_ind(uint8** resultBuffer, Boolean ipConfigured)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  ipConfigured */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_IP_CONFIGURED_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_int16(&buffer, (int16)ipConfigured); /* ipConfigured */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_multicast_address_ind(uint8** resultBuffer, unifi_ListAction action, const unifi_MulticastAddressList* setAddresses)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  action */
    /* packedSize += 1;  setAddresses->numElements */
    {
    int i;
    for (i = 0; i < setAddresses->numElements; i++)
    {
        /* packedSize += 6;  setAddresses->addresses[i].data */
        packedSize += 6;
    }
    }
    packedSize += 3; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_MULTICAST_ADDRESS_IND_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)action); /* action */
    packedLength += event_pack_buffer(&buffer, (uint8*)&setAddresses->numElements, 1); /*lint !e545 !e725    numElements */
    {
    int i;
    for (i = 0; i < setAddresses->numElements; i++)
    {
        packedLength += event_pack_buffer(&buffer, (uint8*)&setAddresses->addresses[i].data, 6); /*lint !e545 !e725    data */
    }
    }
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_tclas_add_cfm(uint8** resultBuffer, unifi_Status status)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_TCLAS_ADD_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_sys_tclas_del_cfm(uint8** resultBuffer, unifi_Status status)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  status */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_SYS_TCLAS_DEL_CFM_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)status); /* status */
    *resultBuffer = evt;
    return packedLength;
}

